import type { Agent } from '../../agent/Agent';
import type { VersionString } from '../../utils/version';
import type { V0_1ToV0_2UpdateConfig } from './updates/0.1-0.2';
export declare const INITIAL_STORAGE_VERSION = "0.1";
export interface Update {
    fromVersion: VersionString;
    toVersion: VersionString;
    doUpdate: (agent: Agent, updateConfig: UpdateConfig) => Promise<void>;
}
export interface UpdateConfig {
    v0_1ToV0_2: V0_1ToV0_2UpdateConfig;
}
export declare const DEFAULT_UPDATE_CONFIG: UpdateConfig;
export declare const supportedUpdates: Update[];
export declare const CURRENT_FRAMEWORK_STORAGE_VERSION: `${number}.${number}`;
